#install.packages("rJava")
library(rJava) 
#install.packages("foreign")
library(foreign)  
#install.packages("xlsx")
library(xlsx)
#install.packages("readstata13")
library(readstata13)
#install.packages("plyr")
library(plyr)
#install.packages("dplyr")
library(dplyr)
#install.packages("descr")
library(descr)
#install.packages("rdrobust")
library(rdrobust)
#install.packages("DataCombine", dependencies=TRUE)
library(DataCombine) 
#install.packages("rdd")
library(rdd)
#install.packages("grid")
library(grid)
#install.packages("gridExtra")
library(gridExtra)
#install.packages("ggplot2")
library(ggplot2)


rm(list=ls())



setwd("/Use/your/cd")


data <- read.csv("Dataset_Media.csv")

data$partycode[data$Partyname=="FDP"]<-5
data$partycode[data$Partyname=="Grune"]<-8
data$partycode[data$Partyname=="Linkspartei"]<-18
data$partycode[data$Partyname=="NPD"]<-13
data$partycode[data$Partyname=="AfD"]<-401

table(data$Partyname)

table(data$State)

table(data$partycode)


data3 <- read.dta("Data.dta")

#Exclude year totals
data$include2<-data$Quarter
data$include2[data$Quarter=="TOT"] <- NA

#Exclude federal elections

data3$include[data3$electiontypecode==1] <- 1
data3$include[data3$electiontypecode==2] <- NA

#Create Quarter indicator for election data

data3$Quarter[data3$month>=1 & data3$month<=3] <- 1
data3$Quarter[data3$month>=4 & data3$month<=6] <- 2
data3$Quarter[data3$month>=7 & data3$month<=9] <- 3
data3$Quarter[data3$month>=10 & data3$month<=12] <- 4

#Subset data

data3_sub<-subset(data3,!is.na(include), c(state, partyname, partycode, year, month, day, Quarter, percentagestate, forcing))


#Merge the two files

data4 <- merge(data, data3_sub, by.x = c("partycode", "State", "Year", "Quarter"), by.y = c("partycode", "state", "year", "Quarter"), all.x = TRUE)

#Exclude cases with missing outcome data


data5<-subset(data4,!is.na(Journal.Mentions))
data6<-subset(data5,!is.na(include2))

#Create lead and lag variables

lead1 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
               slideBy = 1)

lead2 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
               slideBy = 2)

lead3 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
               slideBy = 3)

lead4 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
               slideBy = 4)

lead5 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
               slideBy = 5)

lead6 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
               slideBy = 6)

lead7 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
               slideBy = 7)

lead8 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
               slideBy = 8)

lead9 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
               slideBy = 9)

lead10 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
                slideBy = 10)

lead11 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
                slideBy = 11)

lead12 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
                slideBy = 12)

lead13 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
                slideBy = 13)

lead14 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
                slideBy = 14)

lead15 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
                slideBy = 15)

lead16 <- slide(data6, Var = "Journal.Mentions", GroupVar = "partycode",
                slideBy = 16)

#Analysis


#Create D

lead1$treat[lead1$forcing<0]<-0
lead1$treat[lead1$forcing>=0]<-1

table(lead1$treat)



lead2$treat[lead2$forcing<0]<-0
lead2$treat[lead2$forcing>=0]<-1

table(lead2$treat)


lead3$treat[lead3$forcing<0]<-0
lead3$treat[lead3$forcing>=0]<-1

table(lead3$treat)


lead4$treat[lead4$forcing<0]<-0
lead4$treat[lead4$forcing>=0]<-1


table(lead4$treat)


lead5$treat[lead5$forcing<0]<-0
lead5$treat[lead5$forcing>=0]<-1

lead6$treat[lead6$forcing<0]<-0
lead6$treat[lead6$forcing>=0]<-1

lead7$treat[lead7$forcing<0]<-0
lead7$treat[lead7$forcing>=0]<-1

lead8$treat[lead8$forcing<0]<-0
lead8$treat[lead8$forcing>=0]<-1

lead9$treat[lead9$forcing<0]<-0
lead9$treat[lead9$forcing>=0]<-1

lead10$treat[lead10$forcing<0]<-0
lead10$treat[lead10$forcing>=0]<-1

lead11$treat[lead11$forcing<0]<-0
lead11$treat[lead11$forcing>=0]<-1

lead12$treat[lead12$forcing<0]<-0
lead12$treat[lead12$forcing>=0]<-1

lead13$treat[lead13$forcing<0]<-0
lead13$treat[lead13$forcing>=0]<-1

lead14$treat[lead14$forcing<0]<-0
lead14$treat[lead14$forcing>=0]<-1

lead15$treat[lead15$forcing<0]<-0
lead15$treat[lead15$forcing>=0]<-1

lead16$treat[lead16$forcing<0]<-0
lead16$treat[lead16$forcing>=0]<-1

table(lead16$treat)

#Create window


lead1$window5[lead1$forcing<5.0 & lead1$forcing>-5.0]<-1

lead1_sub<-subset(lead1,!is.na(window5))


lead2$window5[lead2$forcing<5.0 & lead2$forcing>-5.0]<-1

lead2_sub<-subset(lead2,!is.na(window5))


lead3$window5[lead3$forcing<5.0 & lead3$forcing>-5.0]<-1

lead3_sub<-subset(lead3,!is.na(window5))



lead4$window5[lead4$forcing<5.0 & lead4$forcing>-5.0]<-1

lead4_sub<-subset(lead4,!is.na(window5))





lead16$window5[lead16$forcing<5.0 & lead16$forcing>-5.0]<-1

lead16_sub<-subset(lead16,!is.na(window5))

lead16_sub<-subset(lead16_sub,!is.na(Journal.Mentions16))


#Regression

Y1<-lead1$Journal.Mentions1
Y2<-lead2$Journal.Mentions2
Y3<-lead3$Journal.Mentions3
Y4<-lead4$Journal.Mentions4
Y5<-lead5$Journal.Mentions5
Y6<-lead6$Journal.Mentions6
Y7<-lead7$Journal.Mentions7
Y8<-lead8$Journal.Mentions8
Y9<-lead9$Journal.Mentions9
Y10<-lead10$Journal.Mentions10
Y11<-lead11$Journal.Mentions11
Y12<-lead12$Journal.Mentions12
Y13<-lead13$Journal.Mentions13
Y14<-lead14$Journal.Mentions14
Y15<-lead15$Journal.Mentions15
Y16<-lead16$Journal.Mentions16




X1<-lead1$forcing
X2<-lead2$forcing
X3<-lead3$forcing
X4<-lead4$forcing
X5<-lead5$forcing
X6<-lead5$forcing
X7<-lead5$forcing
X8<-lead5$forcing
X9<-lead5$forcing
X10<-lead5$forcing
X11<-lead5$forcing
X12<-lead5$forcing
X13<-lead5$forcing
X14<-lead5$forcing
X15<-lead5$forcing
X16<-lead16$forcing

D<-lead1_sub$treat

table(lead2_sub$Y2)

result1<-RDestimate(Y1 ~ X1, data=lead1, cluster=lead1$yearstate)  
result2<-RDestimate(Y2 ~ X2, data=lead2, cluster=lead2$yearstate)  
result3<-RDestimate(Y3 ~ X3, data=lead3, cluster=lead3$yearstate)  
result4<-RDestimate(Y4 ~ X4, data=lead4, cluster=lead4$yearstate)  
result5<-RDestimate(Y5 ~ X5, data=lead5, cluster=lead5$yearstate)  
result6<-RDestimate(Y6 ~ X6, data=lead6, cluster=lead6$yearstate)  
result7<-RDestimate(Y7 ~ X7, data=lead7, cluster=lead7$yearstate)  
result8<-RDestimate(Y8 ~ X8, data=lead8, cluster=lead8$yearstate)  
result9<-RDestimate(Y9 ~ X9, data=lead9, cluster=lead9$yearstate)  
result10<-RDestimate(Y10 ~ X10, data=lead10, cluster=lead10$yearstate)  
result11<-RDestimate(Y11 ~ X11, data=lead11, cluster=lead11$yearstate)  
result12<-RDestimate(Y12 ~ X12, data=lead12, cluster=lead12$yearstate)  
result13<-RDestimate(Y13 ~ X13, data=lead13, cluster=lead13$yearstate)  
result14<-RDestimate(Y14 ~ X14, data=lead14, cluster=lead14$yearstate)  
result15<-RDestimate(Y15 ~ X15, data=lead15, cluster=lead15$yearstate)  
result16<-RDestimate(Y16 ~ X16, data=lead16, cluster=lead16$yearstate)  


summary(result1) 
summary(result2) 
summary(result3) 
summary(result4) 
summary(result5) 
summary(result6) 
summary(result7) 
summary(result8) 
summary(result9) 
summary(result10) 
summary(result11) 
summary(result12) 
summary(result13) 
summary(result14)
summary(result15) 
summary(result16) 






result1<-RDestimate(Y1 ~ X1, data=lead1, cluster=lead1$yearstate)
res1ik<-data.frame(
  bw=result1$bw,
  est=result1$est,
  id=1,
  rank=seq(1:3),
  ci.hi=result1$est+1.96*result1$se,
  ci.lo=result1$est-1.96*result1$se)


result2<-RDestimate(Y2 ~ X2, data=lead2, cluster=lead2$yearstate)  
res2ik<-data.frame(
  bw=result2$bw,
  est=result2$est,
  id=2,
  rank=seq(1:3),
  ci.hi=result2$est+1.96*result2$se,
  ci.lo=result2$est-1.96*result2$se)

result3<-RDestimate(Y3 ~ X3, data=lead3, cluster=lead3$yearstate)  
res3ik<-data.frame(
  bw=result3$bw,
  est=result3$est,
  id=3,
  rank=seq(1:3),
  ci.hi=result3$est+1.96*result3$se,
  ci.lo=result3$est-1.96*result3$se)

result4<-RDestimate(Y4 ~ X4, data=lead4, cluster=lead4$yearstate)  
res4ik<-data.frame(
  bw=result4$bw,
  est=result4$est,
  id=4,
  rank=seq(1:3),
  ci.hi=result4$est+1.96*result4$se,
  ci.lo=result4$est-1.96*result4$se)

result5<-RDestimate(Y5 ~ X5, data=lead5, cluster=lead5$yearstate)  
res5ik<-data.frame(
  bw=result5$bw,
  est=result5$est,
  id=5,
  rank=seq(1:3),
  ci.hi=result5$est+1.96*result5$se,
  ci.lo=result5$est-1.96*result5$se)

result6<-RDestimate(Y6 ~ X6, data=lead6, cluster=lead6$yearstate)  
res6ik<-data.frame(
  bw=result6$bw,
  est=result6$est,
  id=6,
  rank=seq(1:3),
  ci.hi=result6$est+1.96*result6$se,
  ci.lo=result6$est-1.96*result6$se)

result7<-RDestimate(Y7 ~ X7, data=lead7, cluster=lead7$yearstate)  
res7ik<-data.frame(
  bw=result7$bw,
  est=result7$est,
  id=7,
  rank=seq(1:3),
  ci.hi=result7$est+1.96*result7$se,
  ci.lo=result7$est-1.96*result7$se)

result8<-RDestimate(Y8 ~ X8, data=lead8, cluster=lead8$yearstate)  
res8ik<-data.frame(
  bw=result8$bw,
  est=result8$est,
  id=8,
  rank=seq(1:3),
  ci.hi=result8$est+1.96*result8$se,
  ci.lo=result8$est-1.96*result8$se)

result9<-RDestimate(Y9 ~ X9, data=lead9, cluster=lead9$yearstate)  
res9ik<-data.frame(
  bw=result9$bw,
  est=result9$est,
  id=9,
  rank=seq(1:3),
  ci.hi=result9$est+1.96*result9$se,
  ci.lo=result9$est-1.96*result9$se)

result10<-RDestimate(Y10 ~ X10, data=lead10, cluster=lead10$yearstate)  
res10ik<-data.frame(
  bw=result10$bw,
  est=result1$est,
  id=10,
  rank=seq(1:3),
  ci.hi=result10$est+1.96*result10$se,
  ci.lo=result10$est-1.96*result10$se)

result11<-RDestimate(Y11 ~ X11, data=lead11, cluster=lead11$yearstate)  
res11ik<-data.frame(
  bw=result11$bw,
  est=result11$est,
  id=11,
  rank=seq(1:3),
  ci.hi=result11$est+1.96*result11$se,
  ci.lo=result11$est-1.96*result11$se)

result12<-RDestimate(Y12 ~ X12, data=lead12,cluster=lead12$yearstate)  
res12ik<-data.frame(
  bw=result12$bw,
  est=result12$est,
  id=12,
  rank=seq(1:3),
  ci.hi=result12$est+1.96*result12$se,
  ci.lo=result12$est-1.96*result12$se)

result13<-RDestimate(Y13 ~ X13, data=lead13, cluster=lead13$yearstate)  
res13ik<-data.frame(
  bw=result13$bw,
  est=result13$est,
  id=13,
  rank=seq(1:3),
  ci.hi=result13$est+1.96*result13$se,
  ci.lo=result13$est-1.96*result13$se)

result14<-RDestimate(Y14 ~ X14, data=lead14, cluster=lead14$yearstate)  
res14ik<-data.frame(
  bw=result14$bw,
  est=result14$est,
  id=14,
  rank=seq(1:3),
  ci.hi=result14$est+1.96*result14$se,
  ci.lo=result14$est-1.96*result14$se)

result15<-RDestimate(Y15 ~ X15, data=lead15, cluster=lead15$yearstate)  
res15ik<-data.frame(
  bw=result15$bw,
  est=result15$est,
  id=15,
  rank=seq(1:3),
  ci.hi=result15$est+1.96*result15$se,
  ci.lo=result15$est-1.96*result15$se)

result16<-RDestimate(Y16 ~ X16, data=lead16, cluster=lead16$yearstate)  
res16ik<-data.frame(
  bw=result16$bw,
  est=result16$est,
  id=16,
  rank=seq(1:3),
  ci.hi=result16$est+1.96*result16$se,
  ci.lo=result16$est-1.96*result16$se)


resallik <- rbind(res1ik, res2ik, res3ik, res4ik, res5ik , res6ik , res7ik , res8ik , res9ik , res10ik , res11ik , res12ik , res13ik , res14ik , res15ik , res16ik)


resallik1 <- resallik[resallik$rank==1 ,]

media1=ggplot(resallik1, aes(x = id, y = est)) + 
  geom_pointrange(data=resallik1, mapping=aes(x=id, y=est, ymin=ci.hi, ymax=ci.lo),size=1, color="blue", fill="white", shape=22)  +
  geom_smooth(aes(x = id, y = est), size=2, se = FALSE, span=1.3,color="black") +
  xlab("Time (in Quarters)") + theme(axis.title.x =element_text(color = "black", size = 6)) +
  scale_x_continuous(breaks=c(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)) + 
  ylab("LATE")   + theme(axis.title.y =element_text(color = "black", size = 6)) 
media1

resallik3 <- resallik[resallik$rank==3 ,]

media3=ggplot(resallik3, aes(x = id, y = est)) + 
  geom_pointrange(data=resallik3, mapping=aes(x=id, y=est, ymin=ci.hi, ymax=ci.lo),size=1, color="blue", fill="white", shape=22)  +
  geom_smooth(aes(x = id, y = est), size=2, se = FALSE, span=1.3,color="black") +
  xlab("Time (in Quarters)") + theme(axis.title.x =element_text(color = "black", size = 6)) +
  scale_x_continuous(breaks=c(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)) + 
  ggtitle("Double-Bandwidth") +
  ylab("LATE")   + theme(axis.title.y =element_text(color = "black", size = 6)) 
media3


resallik2 <- resallik[resallik$rank==2 ,]

media2=ggplot(resallik2, aes(x = id, y = est)) + 
  geom_pointrange(data=resallik2, mapping=aes(x=id, y=est, ymin=ci.hi, ymax=ci.lo),size=1, color="blue", fill="white", shape=22)  +
  geom_smooth(aes(x = id, y = est), size=2, se = FALSE, span=1.3,color="black") +
  xlab("Time (in Quarters)") + theme(axis.title.x =element_text(color = "black", size = 6)) +
  scale_x_continuous(breaks=c(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)) + 
  ggtitle("Half-Bandwidth") +
  ylab("LATE")   + theme(axis.title.y =element_text(color = "black", size = 6)) 
media2


grid.arrange(media2, media3, ncol=2, nrow=2)


##########
#Figure 4#
##########

pdf("Media1.pdf")
media1
dev.off()


############
#Figure A.6#
############


pdf("MediaApp.pdf")
grid.arrange(media2, media3, ncol=2, nrow=2)
dev.off()


