#install.packages("rdd")
#install.packages("ri")
#install.packages("dplyr")
#install.packages("MASS")
#install.packages("Matrix")
#install.packages("lattice")
#install.packages("xtable")
#install.packages("ggplot2")
library(MASS)
library(Matrix)
library(lattice)
library(rdd)
library(foreign)
library(ri)
library(dplyr) 
library(xtable)
library(ggplot2)

rm(list = ls())
setwd("/Use/your/cd")



###########################
# Randomization Inference #
###########################

######################
# Balance Table A1 #
######################

# Create bandwidths

rm(list = ls())

data <- read.dta("data.dta")


data$stateper<-data$percentagestate-5

data$treatment[data$stateper>= 0] <- 1
data$treatment[data$stateper< 0] <- 0

table(data$treatment)


data$range0<-NA

data$range0[data$stateper >= 0 & data$stateper<=0.3] <- 1
data$range0[data$stateper < 0 & data$stateper >=-0.4] <- 0
data$range0[data$stateper < -0.4] <- NA
data$range0[data$stateper >0.3] <- NA
table(data$range0)

data$range1<-NA

data$range1[data$stateper >= 0 & data$stateper<=0.4] <- 1
data$range1[data$stateper < 0 & data$stateper >=-0.5] <- 0
data$range1[data$stateper < -0.5] <- NA
data$range1[data$stateper >0.4] <- NA
table(data$range1)

data$range2<-NA

data$range2[data$stateper >= 0 & data$stateper<=0.5] <- 1
data$range2[data$stateper < 0 & data$stateper >= -0.6] <- 0
data$range2[data$stateper < -0.6] <- NA
data$range2[data$stateper >0.5] <- NA
table(data$range2)

data$range3<-NA

data$range3[data$stateper >= 0 & data$stateper<=0.6] <- 1
data$range3[data$stateper < 0 & data$stateper >= -0.7] <- 0
data$range3[data$stateper < -0.7] <- NA
data$range3[data$stateper >0.6] <- NA
table(data$range3)

data$range4<-NA

data$range4[data$stateper >= 0 & data$stateper<=0.7] <- 1
data$range4[data$stateper < 0 & data$stateper >= -0.8] <- 0
data$range4[data$stateper < -0.8] <- NA
data$range4[data$stateper >0.7] <- NA
table(data$range4)

data$range5<-NA

data$range5[data$stateper >= 0 & data$stateper<=0.8] <- 1
data$range5[data$stateper < 0 & data$stateper >= -0.9] <- 0
data$range5[data$stateper < -0.9] <- NA
data$range5[data$stateper >0.8] <- NA
table(data$range5)

data$range6<-NA

data$range6[data$stateper >= 0 & data$stateper<=0.9] <- 1
data$range6[data$stateper < 0 & data$stateper >= -1.0] <- 0
data$range6[data$stateper < -1.0] <- NA
data$range6[data$stateper >0.9] <- NA
table(data$range6)

data$range7<-NA

data$range7[data$stateper >= 0 & data$stateper<=1.0] <- 1
data$range7[data$stateper < 0 & data$stateper >= -1.1] <- 0
data$range7[data$stateper < -1.1] <- NA
data$range7[data$stateper >1.0] <- NA
table(data$range7)

data$range8<-NA

data$range8[data$stateper >= 0 & data$stateper<=1.1] <- 1
data$range8[data$stateper < 0 & data$stateper >= -1.2] <- 0
data$range8[data$stateper < -1.2] <- NA
data$range8[data$stateper >1.1] <- NA
table(data$range8)

data$range9<-NA

data$range9[data$stateper >= 0 & data$stateper<=1.2] <- 1
data$range9[data$stateper < 0 & data$stateper >= -1.3] <- 0
data$range9[data$stateper < -1.3] <- NA
data$range9[data$stateper >1.2] <- NA
table(data$range9)

data$range10<-NA

data$range10[data$stateper >= 0 & data$stateper<=1.3] <- 1
data$range10[data$stateper < 0 & data$stateper >= -1.4] <- 0
data$range10[data$stateper < -1.4] <- NA
data$range10[data$stateper >1.3] <- NA
table(data$range10)

data$range11<-NA

data$range11[data$stateper >= 0 & data$stateper<=1.4] <- 1
data$range11[data$stateper < 0 & data$stateper >= -1.5] <- 0
data$range11[data$stateper < -1.5] <- NA
data$range11[data$stateper >1.4] <- NA
table(data$range11)

data$range12<-NA

data$range12[data$stateper >= 0 & data$stateper<=1.5] <- 1
data$range12[data$stateper < 0 & data$stateper >= -1.6] <- 0
data$range12[data$stateper < -1.6] <- NA
data$range12[data$stateper >1.5] <- NA
table(data$range12)

data$range13<-NA

data$range13[data$stateper >= 0 & data$stateper<=1.6] <- 1
data$range13[data$stateper < 0 & data$stateper >= -1.7] <- 0
data$range13[data$stateper < -1.7] <- NA
data$range13[data$stateper >1.6] <- NA
table(data$range13)

data$range14<-NA

data$range14[data$stateper >= 0 & data$stateper<=1.7] <- 1
data$range14[data$stateper < 0 & data$stateper >= -1.8] <- 0
data$range14[data$stateper < -1.8] <- NA
data$range14[data$stateper >1.7] <- NA
table(data$range14)


data$range15<-NA

data$range15[data$stateper >= 0 & data$stateper<=1.8] <- 1
data$range15[data$stateper < 0 & data$stateper >= -1.9] <- 0
data$range15[data$stateper < -1.9] <- NA
data$range15[data$stateper >1.8] <- NA
table(data$range15)


# Subset range


data2<-subset(data, !is.na(stateper))

data_range0<-subset(data2, !is.na(range0), c(treatment, extremeright, stateper,   greens, fdp, state, statelag1, year, newper))

data_range0$statelag1_1<-data_range0$statelag1
data_range0$statelag1_1[is.na(data_range0$statelag1)]<-mean(data_range0$statelag1, na.rm=TRUE)

data_range0$statelag1_mis[!is.na(data_range0$statelag1)]<-0
data_range0$statelag1_mis[is.na(data_range0$statelag1)]<-1


data_range1<-subset(data2, !is.na(range1), c(treatment, extremeright, stateper,   greens, fdp, state, statelag1, year, newper))

data_range1$statelag1_1<-data_range1$statelag1
data_range1$statelag1_1[is.na(data_range1$statelag1)]<-mean(data_range1$statelag1, na.rm=TRUE)

data_range1$statelag1_mis[!is.na(data_range1$statelag1)]<-0
data_range1$statelag1_mis[is.na(data_range1$statelag1)]<-1


data_range2<-subset(data2, !is.na(range2), c(treatment, extremeright, stateper,  greens, fdp, state, statelag1, year, newper))

data_range2$statelag1_1<-data_range2$statelag1
data_range2$statelag1_1[is.na(data_range2$statelag1)]<-mean(data_range2$statelag1, na.rm=TRUE)

data_range2$statelag1_mis[!is.na(data_range2$statelag1)]<-0
data_range2$statelag1_mis[is.na(data_range2$statelag1)]<-1


data_range3<-subset(data2, !is.na(range3), c(treatment, extremeright, stateper,  greens, fdp, state, statelag1, year, newper))

data_range3$statelag1_1<-data_range3$statelag1
data_range3$statelag1_1[is.na(data_range3$statelag1)]<-mean(data_range3$statelag1, na.rm=TRUE)

data_range3$statelag1_mis[!is.na(data_range3$statelag1)]<-0
data_range3$statelag1_mis[is.na(data_range3$statelag1)]<-1


data_range4<-subset(data2, !is.na(range4), c(treatment, extremeright, stateper,   greens, fdp, state, statelag1, year, newper))

data_range4$statelag1_1<-data_range4$statelag1
data_range4$statelag1_1[is.na(data_range4$statelag1)]<-mean(data_range4$statelag1, na.rm=TRUE)

data_range4$statelag1_mis[!is.na(data_range4$statelag1)]<-0
data_range4$statelag1_mis[is.na(data_range4$statelag1)]<-1


data_range5<-subset(data2, !is.na(range5), c(treatment, extremeright, stateper,   greens, fdp, state, statelag1, year, newper))

data_range5$statelag1_1<-data_range5$statelag1
data_range5$statelag1_1[is.na(data_range5$statelag1)]<-mean(data_range5$statelag1, na.rm=TRUE)

data_range5$statelag1_mis[!is.na(data_range5$statelag1)]<-0
data_range5$statelag1_mis[is.na(data_range5$statelag1)]<-1



data_range6<-subset(data2, !is.na(range6), c(treatment, extremeright, stateper,  greens, fdp, state, statelag1, year, newper))

data_range6$statelag1_1<-data_range6$statelag1
data_range6$statelag1_1[is.na(data_range6$statelag1)]<-mean(data_range6$statelag1, na.rm=TRUE)

data_range6$statelag1_mis[!is.na(data_range6$statelag1)]<-0
data_range6$statelag1_mis[is.na(data_range6$statelag1)]<-1


data_range7<-subset(data2, !is.na(range7), c(treatment, extremeright, stateper,  greens, fdp, state, statelag1, year, newper))

data_range7$statelag1_1<-data_range7$statelag1
data_range7$statelag1_1[is.na(data_range7$statelag1)]<-mean(data_range7$statelag1, na.rm=TRUE)

data_range7$statelag1_mis[!is.na(data_range7$statelag1)]<-0
data_range7$statelag1_mis[is.na(data_range7$statelag1)]<-1



data_range8<-subset(data2, !is.na(range8), c(treatment, extremeright, stateper,   greens, fdp, state, statelag1, year, newper))

data_range8$statelag1_1<-data_range8$statelag1
data_range8$statelag1_1[is.na(data_range8$statelag1)]<-mean(data_range8$statelag1, na.rm=TRUE)

data_range8$statelag1_mis[!is.na(data_range8$statelag1)]<-0
data_range8$statelag1_mis[is.na(data_range8$statelag1)]<-1



data_range9<-subset(data2, !is.na(range9), c(treatment, extremeright, stateper, greens, fdp, state, statelag1, year, newper))

data_range9$statelag1_1<-data_range9$statelag1
data_range9$statelag1_1[is.na(data_range9$statelag1)]<-mean(data_range9$statelag1, na.rm=TRUE)

data_range9$statelag1_mis[!is.na(data_range9$statelag1)]<-0
data_range9$statelag1_mis[is.na(data_range9$statelag1)]<-1


data_range10<-subset(data2, !is.na(range10), c(treatment, extremeright, stateper,  greens, fdp, state, statelag1, year, newper))

data_range10$statelag1_1<-data_range10$statelag1
data_range10$statelag1_1[is.na(data_range10$statelag1)]<-mean(data_range10$statelag1, na.rm=TRUE)

data_range10$statelag1_mis[!is.na(data_range10$statelag1)]<-0
data_range10$statelag1_mis[is.na(data_range10$statelag1)]<-1



data_range11<-subset(data2, !is.na(range11), c(treatment, extremeright, stateper,   greens, fdp, state, statelag1, year, newper))

data_range11$statelag1_1<-data_range11$statelag1
data_range11$statelag1_1[is.na(data_range11$statelag1)]<-mean(data_range11$statelag1, na.rm=TRUE)

data_range11$statelag1_mis[!is.na(data_range11$statelag1)]<-0
data_range11$statelag1_mis[is.na(data_range11$statelag1)]<-1




data_range12<-subset(data2, !is.na(range12), c(treatment, extremeright, stateper,   greens, fdp, state, statelag1, year, newper))

data_range12$statelag1_1<-data_range12$statelag1
data_range12$statelag1_1[is.na(data_range12$statelag1)]<-mean(data_range12$statelag1, na.rm=TRUE)

data_range12$statelag1_mis[!is.na(data_range12$statelag1)]<-0
data_range12$statelag1_mis[is.na(data_range12$statelag1)]<-1



data_range13<-subset(data2, !is.na(range13), c(treatment, extremeright, stateper,  greens, fdp, state, statelag1, year, newper))

data_range13$statelag1_1<-data_range13$statelag1
data_range13$statelag1_1[is.na(data_range13$statelag1)]<-mean(data_range13$statelag1, na.rm=TRUE)

data_range13$statelag1_mis[!is.na(data_range13$statelag1)]<-0
data_range13$statelag1_mis[is.na(data_range13$statelag1)]<-1



data_range14<-subset(data2, !is.na(range14), c(treatment, extremeright, stateper,  greens, fdp, state, statelag1, year, newper))

data_range14$statelag1_1<-data_range14$statelag1
data_range14$statelag1_1[is.na(data_range14$statelag1)]<-mean(data_range14$statelag1, na.rm=TRUE)

data_range14$statelag1_mis[!is.na(data_range14$statelag1)]<-0
data_range14$statelag1_mis[is.na(data_range14$statelag1)]<-1




data_range15<-subset(data2, !is.na(range15), c(treatment, extremeright, stateper,  greens, fdp, state, statelag1, year, newper))

data_range15$statelag1_1<-data_range15$statelag1
data_range15$statelag1_1[is.na(data_range15$statelag1)]<-mean(data_range15$statelag1, na.rm=TRUE)

data_range15$statelag1_mis[!is.na(data_range15$statelag1)]<-0
data_range15$statelag1_mis[is.na(data_range15$statelag1)]<-1





data2$firsttwoyears<-NA

data2$firsttwoyears[data2$days<=851]<-1

data_below<-subset(data2,!is.na(firsttwoyears))

data_range0_below<-subset(data_below, !is.na(range0), c( treatment, extremeright, stateper,   greens, fdp, state,  year, newper, statelag1))

data_range0_below$statelag1_1<-data_range0_below$statelag1
data_range0_below$statelag1_1[is.na(data_range0_below$statelag1)]<-mean(data_range0_below$statelag1, na.rm=TRUE)

data_range0_below$statelag1_mis[!is.na(data_range0_below$statelag1)]<-0
data_range0_below$statelag1_mis[is.na(data_range0_below$statelag1)]<-1


data_range1_below<-subset(data_below, !is.na(range1), c( treatment, extremeright, stateper,   greens, fdp, state,  year, newper, statelag1))

data_range1_below$statelag1_1<-data_range1_below$statelag1
data_range1_below$statelag1_1[is.na(data_range1_below$statelag1)]<-mean(data_range1_below$statelag1, na.rm=TRUE)

data_range1_below$statelag1_mis[!is.na(data_range1_below$statelag1)]<-0
data_range1_below$statelag1_mis[is.na(data_range1_below$statelag1)]<-1



data_range2_below<-subset(data_below, !is.na(range2), c( treatment, extremeright, stateper,   greens, fdp, state,  year, newper, statelag1))

data_range2_below$statelag1_1<-data_range2_below$statelag1
data_range2_below$statelag1_1[is.na(data_range2_below$statelag1)]<-mean(data_range2_below$statelag1, na.rm=TRUE)

data_range2_below$statelag1_mis[!is.na(data_range2_below$statelag1)]<-0
data_range2_below$statelag1_mis[is.na(data_range2_below$statelag1)]<-1


data_range3_below<-subset(data_below, !is.na(range3), c( treatment, extremeright, stateper,  greens, fdp, state,  year, newper, statelag1))

data_range3_below$statelag1_1<-data_range3_below$statelag1
data_range3_below$statelag1_1[is.na(data_range3_below$statelag1)]<-mean(data_range3_below$statelag1, na.rm=TRUE)

data_range3_below$statelag1_mis[!is.na(data_range3_below$statelag1)]<-0
data_range3_below$statelag1_mis[is.na(data_range3_below$statelag1)]<-1



data_range4_below<-subset(data_below, !is.na(range4), c( treatment, extremeright, stateper,   greens, fdp, state,  year, newper, statelag1))

data_range4_below$statelag1_1<-data_range4_below$statelag1
data_range4_below$statelag1_1[is.na(data_range4_below$statelag1)]<-mean(data_range4_below$statelag1, na.rm=TRUE)

data_range4_below$statelag1_mis[!is.na(data_range4_below$statelag1)]<-0
data_range4_below$statelag1_mis[is.na(data_range4_below$statelag1)]<-1



data_range5_below<-subset(data_below, !is.na(range5), c( treatment, extremeright, stateper,   greens, fdp, state,  year, newper, statelag1))

data_range5_below$statelag1_1<-data_range5_below$statelag1
data_range5_below$statelag1_1[is.na(data_range5_below$statelag1)]<-mean(data_range5_below$statelag1, na.rm=TRUE)

data_range5_below$statelag1_mis[!is.na(data_range5_below$statelag1)]<-0
data_range5_below$statelag1_mis[is.na(data_range5_below$statelag1)]<-1


data_range6_below<-subset(data_below, !is.na(range6), c( treatment, extremeright, stateper,   greens, fdp, state,  year, newper, statelag1))

data_range6_below$statelag1_1<-data_range6_below$statelag1
data_range6_below$statelag1_1[is.na(data_range6_below$statelag1)]<-mean(data_range6_below$statelag1, na.rm=TRUE)

data_range6_below$statelag1_mis[!is.na(data_range6_below$statelag1)]<-0
data_range6_below$statelag1_mis[is.na(data_range6_below$statelag1)]<-1


data_range7_below<-subset(data_below, !is.na(range7), c( treatment, extremeright, stateper,  greens, fdp, state,  year, newper, statelag1))

data_range7_below$statelag1_1<-data_range7_below$statelag1
data_range7_below$statelag1_1[is.na(data_range7_below$statelag1)]<-mean(data_range7_below$statelag1, na.rm=TRUE)

data_range7_below$statelag1_mis[!is.na(data_range7_below$statelag1)]<-0
data_range7_below$statelag1_mis[is.na(data_range7_below$statelag1)]<-1


data_range8_below<-subset(data_below, !is.na(range8), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range8_below$statelag1_1<-data_range8_below$statelag1
data_range8_below$statelag1_1[is.na(data_range8_below$statelag1)]<-mean(data_range8_below$statelag1, na.rm=TRUE)

data_range8_below$statelag1_mis[!is.na(data_range8_below$statelag1)]<-0
data_range8_below$statelag1_mis[is.na(data_range8_below$statelag1)]<-1


data_range9_below<-subset(data_below, !is.na(range9), c( treatment, extremeright, stateper,   greens, fdp, state,  year, newper, statelag1))

data_range9_below$statelag1_1<-data_range9_below$statelag1
data_range9_below$statelag1_1[is.na(data_range9_below$statelag1)]<-mean(data_range9_below$statelag1, na.rm=TRUE)

data_range9_below$statelag1_mis[!is.na(data_range9_below$statelag1)]<-0
data_range9_below$statelag1_mis[is.na(data_range9_below$statelag1)]<-1


data_range10_below<-subset(data_below, !is.na(range10), c( treatment, extremeright, stateper, greens, fdp, state,  year, newper, statelag1))

data_range10_below$statelag1_1<-data_range10_below$statelag1
data_range10_below$statelag1_1[is.na(data_range10_below$statelag1)]<-mean(data_range10_below$statelag1, na.rm=TRUE)

data_range10_below$statelag1_mis[!is.na(data_range10_below$statelag1)]<-0
data_range10_below$statelag1_mis[is.na(data_range10_below$statelag1)]<-1



data_range11_below<-subset(data_below, !is.na(range11), c( treatment, extremeright, stateper,   greens, fdp, state,  year, newper, statelag1))

data_range11_below$statelag1_1<-data_range11_below$statelag1
data_range11_below$statelag1_1[is.na(data_range11_below$statelag1)]<-mean(data_range11_below$statelag1, na.rm=TRUE)

data_range11_below$statelag1_mis[!is.na(data_range11_below$statelag1)]<-0
data_range11_below$statelag1_mis[is.na(data_range11_below$statelag1)]<-1


data_range12_below<-subset(data_below, !is.na(range12), c( treatment, extremeright, stateper,   greens, fdp, state,  year, newper, statelag1))

data_range12_below$statelag1_1<-data_range12_below$statelag1
data_range12_below$statelag1_1[is.na(data_range12_below$statelag1)]<-mean(data_range12_below$statelag1, na.rm=TRUE)

data_range12_below$statelag1_mis[!is.na(data_range12_below$statelag1)]<-0
data_range12_below$statelag1_mis[is.na(data_range12_below$statelag1)]<-1


data_range13_below<-subset(data_below, !is.na(range13), c( treatment, extremeright, stateper, greens, fdp, state,  year, newper, statelag1))

data_range13_below$statelag1_1<-data_range13_below$statelag1
data_range13_below$statelag1_1[is.na(data_range13_below$statelag1)]<-mean(data_range13_below$statelag1, na.rm=TRUE)

data_range13_below$statelag1_mis[!is.na(data_range13_below$statelag1)]<-0
data_range13_below$statelag1_mis[is.na(data_range13_below$statelag1)]<-1


data_range14_below<-subset(data_below, !is.na(range14), c( treatment, extremeright, stateper,   greens, fdp, state,  year, newper, statelag1))

data_range14_below$statelag1_1<-data_range14_below$statelag1
data_range14_below$statelag1_1[is.na(data_range14_below$statelag1)]<-mean(data_range14_below$statelag1, na.rm=TRUE)

data_range14_below$statelag1_mis[!is.na(data_range14_below$statelag1)]<-0
data_range14_below$statelag1_mis[is.na(data_range14_below$statelag1)]<-1


data_range15_below<-subset(data_below, !is.na(range15), c( treatment, extremeright, stateper,  greens, fdp, state,  year, newper, statelag1))

data_range15_below$statelag1_1<-data_range15_below$statelag1
data_range15_below$statelag1_1[is.na(data_range0_below$statelag1)]<-mean(data_range15_below$statelag1, na.rm=TRUE)

data_range15_below$statelag1_mis[!is.na(data_range15_below$statelag1)]<-0
data_range15_below$statelag1_mis[is.na(data_range15_below$statelag1)]<-1




data2$lasttwoyears<-NA

data2$lasttwoyears[data2$days>851]<-1

data_above<-subset(data2,!is.na(lasttwoyears))

data_range0_above<-subset(data_above, !is.na(range0), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range0_above$statelag1_1<-data_range0_above$statelag1
data_range0_above$statelag1_1[is.na(data_range0_above$statelag1)]<-mean(data_range0_above$statelag1, na.rm=TRUE)

data_range0_above$statelag1_mis[!is.na(data_range0_above$statelag1)]<-0
data_range0_above$statelag1_mis[is.na(data_range0_above$statelag1)]<-1


data_range1_above<-subset(data_above, !is.na(range1), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range1_above$statelag1_1<-data_range1_above$statelag1
data_range1_above$statelag1_1[is.na(data_range1_above$statelag1)]<-mean(data_range1_above$statelag1, na.rm=TRUE)

data_range1_above$statelag1_mis[!is.na(data_range1_above$statelag1)]<-0
data_range1_above$statelag1_mis[is.na(data_range1_above$statelag1)]<-1



data_range2_above<-subset(data_above, !is.na(range2), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range2_above$statelag1_1<-data_range2_above$statelag1
data_range2_above$statelag1_1[is.na(data_range2_above$statelag1)]<-mean(data_range2_above$statelag1, na.rm=TRUE)

data_range2_above$statelag1_mis[!is.na(data_range2_above$statelag1)]<-0
data_range2_above$statelag1_mis[is.na(data_range2_above$statelag1)]<-1


data_range3_above<-subset(data_above, !is.na(range3), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range3_above$statelag1_1<-data_range3_above$statelag1
data_range3_above$statelag1_1[is.na(data_range3_above$statelag1)]<-mean(data_range3_above$statelag1, na.rm=TRUE)

data_range3_above$statelag1_mis[!is.na(data_range3_above$statelag1)]<-0
data_range3_above$statelag1_mis[is.na(data_range3_above$statelag1)]<-1


data_range4_above<-subset(data_above, !is.na(range4), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range4_above$statelag1_1<-data_range4_above$statelag1
data_range4_above$statelag1_1[is.na(data_range4_above$statelag1)]<-mean(data_range4_above$statelag1, na.rm=TRUE)

data_range4_above$statelag1_mis[!is.na(data_range4_above$statelag1)]<-0
data_range4_above$statelag1_mis[is.na(data_range4_above$statelag1)]<-1



data_range5_above<-subset(data_above, !is.na(range5), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range5_above$statelag1_1<-data_range5_above$statelag1
data_range5_above$statelag1_1[is.na(data_range5_above$statelag1)]<-mean(data_range5_above$statelag1, na.rm=TRUE)

data_range5_above$statelag1_mis[!is.na(data_range5_above$statelag1)]<-0
data_range5_above$statelag1_mis[is.na(data_range5_above$statelag1)]<-1


data_range6_above<-subset(data_above, !is.na(range6), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))


data_range6_above$statelag1_1<-data_range6_above$statelag1
data_range6_above$statelag1_1[is.na(data_range6_above$statelag1)]<-mean(data_range6_above$statelag1, na.rm=TRUE)

data_range6_above$statelag1_mis[!is.na(data_range6_above$statelag1)]<-0
data_range6_above$statelag1_mis[is.na(data_range6_above$statelag1)]<-1


data_range7_above<-subset(data_above, !is.na(range7), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range7_above$statelag1_1<-data_range7_above$statelag1
data_range7_above$statelag1_1[is.na(data_range7_above$statelag1)]<-mean(data_range7_above$statelag1, na.rm=TRUE)

data_range7_above$statelag1_mis[!is.na(data_range7_above$statelag1)]<-0
data_range7_above$statelag1_mis[is.na(data_range7_above$statelag1)]<-1


data_range8_above<-subset(data_above, !is.na(range8), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range8_above$statelag1_1<-data_range8_above$statelag1
data_range8_above$statelag1_1[is.na(data_range8_above$statelag1)]<-mean(data_range8_above$statelag1, na.rm=TRUE)

data_range8_above$statelag1_mis[!is.na(data_range8_above$statelag1)]<-0
data_range8_above$statelag1_mis[is.na(data_range8_above$statelag1)]<-1


data_range9_above<-subset(data_above, !is.na(range9), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range9_above$statelag1_1<-data_range9_above$statelag1
data_range9_above$statelag1_1[is.na(data_range9_above$statelag1)]<-mean(data_range9_above$statelag1, na.rm=TRUE)

data_range9_above$statelag1_mis[!is.na(data_range9_above$statelag1)]<-0
data_range9_above$statelag1_mis[is.na(data_range9_above$statelag1)]<-1


data_range10_above<-subset(data_above, !is.na(range10), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range10_above$statelag1_1<-data_range10_above$statelag1
data_range10_above$statelag1_1[is.na(data_range10_above$statelag1)]<-mean(data_range1_above$statelag1, na.rm=TRUE)

data_range10_above$statelag1_mis[!is.na(data_range10_above$statelag1)]<-0
data_range10_above$statelag1_mis[is.na(data_range10_above$statelag1)]<-1



data_range11_above<-subset(data_above, !is.na(range11), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range11_above$statelag1_1<-data_range11_above$statelag1
data_range11_above$statelag1_1[is.na(data_range11_above$statelag1)]<-mean(data_range11_above$statelag1, na.rm=TRUE)

data_range11_above$statelag1_mis[!is.na(data_range11_above$statelag1)]<-0
data_range11_above$statelag1_mis[is.na(data_range11_above$statelag1)]<-1


data_range12_above<-subset(data_above, !is.na(range12), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range12_above$statelag1_1<-data_range12_above$statelag1
data_range12_above$statelag1_1[is.na(data_range12_above$statelag1)]<-mean(data_range12_above$statelag1, na.rm=TRUE)

data_range12_above$statelag1_mis[!is.na(data_range12_above$statelag1)]<-0
data_range12_above$statelag1_mis[is.na(data_range12_above$statelag1)]<-1



data_range13_above<-subset(data_above, !is.na(range13), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range13_above$statelag1_1<-data_range13_above$statelag1
data_range13_above$statelag1_1[is.na(data_range13_above$statelag1)]<-mean(data_range13_above$statelag1, na.rm=TRUE)

data_range13_above$statelag1_mis[!is.na(data_range13_above$statelag1)]<-0
data_range13_above$statelag1_mis[is.na(data_range13_above$statelag1)]<-1



data_range14_above<-subset(data_above, !is.na(range14), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range14_above$statelag1_1<-data_range14_above$statelag1
data_range14_above$statelag1_1[is.na(data_range14_above$statelag1)]<-mean(data_range14_above$statelag1, na.rm=TRUE)

data_range14_above$statelag1_mis[!is.na(data_range14_above$statelag1)]<-0
data_range14_above$statelag1_mis[is.na(data_range14_above$statelag1)]<-1



data_range15_above<-subset(data_above, !is.na(range15), c( treatment, extremeright, stateper,    greens, fdp, state,  year, newper, statelag1))

data_range15_above$statelag1_1<-data_range15_above$statelag1
data_range15_above$statelag1_1[is.na(data_range15_above$statelag1)]<-mean(data_range15_above$statelag1, na.rm=TRUE)

data_range15_above$statelag1_mis[!is.na(data_range15_above$statelag1)]<-0
data_range15_above$statelag1_mis[is.na(data_range15_above$statelag1)]<-1


#write functions
    
    pvalfunct <- function(x){
      
      Z<-x$treatment
      
      numiter <- 5000
      
      set.seed(1234567)
      
      perms <-  genperms(Z,maxiter=numiter)    
      numiter <- ncol(perms) 
      
      Fstat <- summary(lm(Z~factor(state)+year+greens+fdp+statelag1_1+statelag1_mis, data=x))$fstatistic[1]   
      Fstat
      Fstatstore <- rep(NA,numiter)
      
      # F-statistic under the null of random assignment of Z
      for (i in 1:numiter) {
        Fstatstore[i] <- summary(lm(perms[,i]~factor(state)+year+greens+fdp+statelag1_1+statelag1_mis, data=x))$fstatistic[1]   
      }
      
      est<-mean(Fstatstore >= Fstat)
      
      
      return(est)
    }    
    


#save estimates

pval_.3<-pvalfunct(data_range0)

N_.3_treatment<-table(data_range0$treatment)[2]
N_.3_control<-table(data_range0$treatment)[1]


pval_.4<-pvalfunct(data_range1)

N_.4_treatment<-table(data_range1$treatment)[2]
N_.4_control<-table(data_range1$treatment)[1]


pval_.5<-pvalfunct(data_range2)

N_.5_treatment<-table(data_range2$treatment)[2]
N_.5_control<-table(data_range2$treatment)[1]


pval_.6<-pvalfunct(data_range3) 

N_.6_treatment<-table(data_range3$treatment)[2]
N_.6_control<-table(data_range3$treatment)[1]


pval_.7<-pvalfunct(data_range4) #cut-off

N_.7_treatment<-table(data_range4$treatment)[2]
N_.7_control<-table(data_range4$treatment)[1]


pval_.8<-pvalfunct(data_range5)

N_.8_treatment<-table(data_range5$treatment)[2]
N_.8_control<-table(data_range5$treatment)[1]

pval_.9<-pvalfunct(data_range6)

N_.9_treatment<-table(data_range6$treatment)[2]
N_.9_control<-table(data_range6$treatment)[1]


pval_1.0<-pvalfunct(data_range7)

N_1.0_treatment<-table(data_range7$treatment)[2]
N_1.0_control<-table(data_range7$treatment)[1]


pval_1.1<-pvalfunct(data_range8)


N_1.1_treatment<-table(data_range8$treatment)[2]
N_1.1_control<-table(data_range8$treatment)[1]


pval_1.2<-pvalfunct(data_range9)

N_1.2_treatment<-table(data_range9$treatment)[2]
N_1.2_control<-table(data_range9$treatment)[1]


pval_1.3<-NA
N_1.3_treatment<-NA
N_1.3_control<-NA

pval_1.4<-NA
N_1.4_treatment<-NA
N_1.4_control<-NA

pval_1.5<-NA
N_1.5_treatment<-NA
N_1.5_control<-NA

pval_1.6<-NA
N_1.6_treatment<-NA
N_1.6_control<-NA

pval_1.7<-NA
N_1.7_treatment<-NA
N_1.7_control<-NA

pval_1.8<-NA
N_1.8_treatment<-NA
N_1.8_control<-NA


#Below

pval_.3_below<-pvalfunct(data_range0_below)

N_.3_below_treatment<-table(data_range0_below$treatment)[2] 
N_.3_below_control<-table(data_range0_below$treatment)[1] 


pval_.4_below<-pvalfunct(data_range1_below)
 
N_.4_below_treatment<-table(data_range1_below$treatment)[2] 
N_.4_below_control<-table(data_range1_below$treatment)[1] 


pval_.5_below<-pvalfunct(data_range2_below)

N_.5_below_treatment<-table(data_range2_below$treatment)[2] 
N_.5_below_control<-table(data_range2_below$treatment)[1] 


pval_.6_below<-pvalfunct(data_range3_below)

N_.6_below_treatment<-table(data_range3_below$treatment)[2] 
N_.6_below_control<-table(data_range3_below$treatment)[1] 


pval_.7_below<-pvalfunct(data_range4_below) #0.1362, 26, 35

N_.7_below_treatment<-table(data_range4_below$treatment)[2] 
N_.7_below_control<-table(data_range4_below$treatment)[1] 


pval_.8_below<-pvalfunct(data_range5_below)

N_.8_below_treatment<-table(data_range5_below$treatment)[2] 
N_.8_below_control<-table(data_range5_below$treatment)[1] 


pval_.9_below<-pvalfunct(data_range6_below) 

N_.9_below_treatment<-table(data_range6_below$treatment)[2] 
N_.9_below_control<-table(data_range6_below$treatment)[1] 


pval_1.0_below<-pvalfunct(data_range7_below)

N_1.0_below_treatment<-table(data_range7_below$treatment)[2] 
N_1.0_below_control<-table(data_range7_below$treatment)[1] 


pval_1.1_below<-pvalfunct(data_range8_below)

N_1.1_below_treatment<-table(data_range8_below$treatment)[2] 
N_1.1_below_control<-table(data_range8_below$treatment)[1] 


pval_1.2_below<-pvalfunct(data_range9_below)

N_1.2_below_treatment<-table(data_range9_below$treatment)[2] 
N_1.2_below_control<-table(data_range9_below$treatment)[1] 

pval_1.3_below<-NA
N_1.3_below_treatment<-NA
N_1.3_below_control<-NA

pval_1.4_below<-NA
N_1.4_below_treatment<-NA
N_1.4_below_control<-NA

pval_1.5_below<-NA
N_1.5_below_treatment<-NA
N_1.5_below_control<-NA

pval_1.6_below<-NA
N_1.6_below_treatment<-NA
N_1.6_below_control<-NA

pval_1.7_below<-NA
N_1.7_below_treatment<-NA
N_1.7_below_control<-NA

pval_1.8_below<-NA
N_1.8_below_treatment<-NA
N_1.8_below_control<-NA

#Above

pval_.3_above<-pvalfunct(data_range0_above)

N_.3_above_treatment<-table(data_range0_above$treatment)[2]
N_.3_above_control<-table(data_range0_above$treatment)[1]

pval_.4_above<-pvalfunct(data_range1_above)

N_.4_above_treatment<-table(data_range1_above$treatment)[2]
N_.4_above_control<-table(data_range1_above$treatment)[1]

pval_.5_above<-pvalfunct(data_range2_above)

N_.5_above_treatment<-table(data_range2_above$treatment)[2]
N_.5_above_control<-table(data_range2_above$treatment)[1]

pval_.6_above<-pvalfunct(data_range3_above)

N_.6_above_treatment<-table(data_range3_above$treatment)[2]
N_.6_above_control<-table(data_range3_above$treatment)[1]

pval_.7_above<-pvalfunct(data_range4_above) 

N_.7_above_treatment<-table(data_range4_above$treatment)[2]
N_.7_above_control<-table(data_range4_above$treatment)[1]

pval_.8_above<-pvalfunct(data_range5_above)

N_.8_above_treatment<-table(data_range5_above$treatment)[2]
N_.8_above_control<-table(data_range5_above$treatment)[1]

pval_.9_above<-pvalfunct(data_range6_above)

N_.9_above_treatment<-table(data_range6_above$treatment)[2]
N_.9_above_control<-table(data_range6_above$treatment)[1]


pval_1.0_above<-pvalfunct(data_range7_above)

N_1.0_above_treatment<-table(data_range7_above$treatment)[2]
N_1.0_above_control<-table(data_range7_above$treatment)[1]


pval_1.1_above<-pvalfunct(data_range8_above)

N_1.1_above_treatment<-table(data_range8_above$treatment)[2]
N_1.1_above_control<-table(data_range8_above$treatment)[1]


pval_1.2_above<-pvalfunct(data_range9_above)  

N_1.2_above_treatment<-table(data_range9_above$treatment)[2]
N_1.2_above_control<-table(data_range9_above$treatment)[1]


pval_1.3_above<-pvalfunct(data_range10_above) 

N_1.3_above_treatment<-table(data_range10_above$treatment)[2]
N_1.3_above_control<-table(data_range10_above$treatment)[1]


pval_1.4_above<-pvalfunct(data_range11_above)

N_1.4_above_treatment<-table(data_range11_above$treatment)[2]
N_1.4_above_control<-table(data_range11_above$treatment)[1]


pval_1.5_above<-pvalfunct(data_range12_above)

N_1.5_above_treatment<-table(data_range12_above$treatment)[2]
N_1.5_above_control<-table(data_range12_above$treatment)[1]


pval_1.6_above<-pvalfunct(data_range13_above)

N_1.6_above_treatment<-table(data_range13_above$treatment)[2]
N_1.6_above_control<-table(data_range13_above$treatment)[1]


pval_1.7_above<-pvalfunct(data_range14_above)

N_1.7_above_treatment<-table(data_range14_above$treatment)[2]
N_1.7_above_control<-table(data_range14_above$treatment)[1]


pval_1.8_above<-pvalfunct(data_range15_above)

N_1.8_above_treatment<-table(data_range15_above$treatment)[2]
N_1.8_above_control<-table(data_range15_above$treatment)[1]



#Membership

data_members <- read.dta("membership.dta")

data_members$stateper<-data_members$percentage-5

data_members$treatment[data_members$stateper>= 0] <- 1
data_members$treatment[data_members$stateper< 0] <- 0

table(data_members$treatment)

data_members$range0<-NA

data_members$range0[data_members$stateper >= 0 & data_members$stateper<=0.3] <- 1
data_members$range0[data_members$stateper < 0 & data_members$stateper >=-0.4] <- 0
data_members$range0[data_members$stateper < -0.4] <- NA
data_members$range0[data_members$stateper >0.3] <- NA
table(data_members$range0)

data_members$range1<-NA

data_members$range1[data_members$stateper >= 0 & data_members$stateper<=0.4] <- 1
data_members$range1[data_members$stateper < 0 & data_members$stateper >=-0.5] <- 0
data_members$range1[data_members$stateper < -0.5] <- NA
data_members$range1[data_members$stateper >0.4] <- NA
table(data_members$range1)

data_members$range2<-NA

data_members$range2[data_members$stateper >= 0 & data_members$stateper<=0.5] <- 1
data_members$range2[data_members$stateper < 0 & data_members$stateper >= -0.6] <- 0
data_members$range2[data_members$stateper < -0.6] <- NA
data_members$range2[data_members$stateper >0.5] <- NA
table(data_members$range2)

data_members$range3<-NA

data_members$range3[data_members$stateper >= 0 & data_members$stateper<=0.6] <- 1
data_members$range3[data_members$stateper < 0 & data_members$stateper >= -0.7] <- 0
data_members$range3[data_members$stateper < -0.7] <- NA
data_members$range3[data_members$stateper >0.6] <- NA
table(data_members$range3)

data_members$range4<-NA

data_members$range4[data_members$stateper >= 0 & data_members$stateper<=0.7] <- 1
data_members$range4[data_members$stateper < 0 & data_members$stateper >= -0.8] <- 0
data_members$range4[data_members$stateper < -0.8] <- NA
data_members$range4[data_members$stateper >0.7] <- NA
table(data_members$range4)

data_members$range5<-NA

data_members$range5[data_members$stateper >= 0 & data_members$stateper<=0.8] <- 1
data_members$range5[data_members$stateper < 0 & data_members$stateper >= -0.9] <- 0
data_members$range5[data_members$stateper < -0.9] <- NA
data_members$range5[data_members$stateper >0.8] <- NA
table(data_members$range5)

data_members$range6<-NA

data_members$range6[data_members$stateper >= 0 & data_members$stateper<=0.9] <- 1
data_members$range6[data_members$stateper < 0 & data_members$stateper >= -1.0] <- 0
data_members$range6[data_members$stateper < -1.0] <- NA
data_members$range6[data_members$stateper >0.9] <- NA
table(data_members$range6)

data_members$range7<-NA

data_members$range7[data_members$stateper >= 0 & data_members$stateper<=1.0] <- 1
data_members$range7[data_members$stateper < 0 & data_members$stateper >= -1.1] <- 0
data_members$range7[data_members$stateper < -1.1] <- NA
data_members$range7[data_members$stateper >1.0] <- NA
table(data_members$range7)

data_members$range8<-NA

data_members$range8[data_members$stateper >= 0 & data_members$stateper<=1.1] <- 1
data_members$range8[data_members$stateper < 0 & data_members$stateper >= -1.2] <- 0
data_members$range8[data_members$stateper < -1.2] <- NA
data_members$range8[data_members$stateper >1.1] <- NA
table(data_members$range8)

data_members$range9<-NA

data_members$range9[data_members$stateper >= 0 & data_members$stateper<=1.2] <- 1
data_members$range9[data_members$stateper < 0 & data_members$stateper >= -1.3] <- 0
data_members$range9[data_members$stateper < -1.3] <- NA
data_members$range9[data_members$stateper >1.2] <- NA
table(data_members$range9)

data_members$range10<-NA

data_members$range10[data_members$stateper >= 0 & data_members$stateper<=1.3] <- 1
data_members$range10[data_members$stateper < 0 & data_members$stateper >= -1.4] <- 0
data_members$range10[data_members$stateper < -1.4] <- NA
data_members$range10[data_members$stateper >1.3] <- NA
table(data_members$range10)

data_members$range11<-NA

data_members$range11[data_members$stateper >= 0 & data_members$stateper<=1.4] <- 1
data_members$range11[data_members$stateper < 0 & data_members$stateper >= -1.5] <- 0
data_members$range11[data_members$stateper < -1.5] <- NA
data_members$range11[data_members$stateper >1.4] <- NA
table(data_members$range11)

data_members$range12<-NA

data_members$range12[data_members$stateper >= 0 & data_members$stateper<=1.5] <- 1
data_members$range12[data_members$stateper < 0 & data_members$stateper >= -1.6] <- 0
data_members$range12[data_members$stateper < -1.6] <- NA
data_members$range12[data_members$stateper >1.5] <- NA
table(data_members$range12)

data_members$range13<-NA

data_members$range13[data_members$stateper >= 0 & data_members$stateper<=1.6] <- 1
data_members$range13[data_members$stateper < 0 & data_members$stateper >= -1.7] <- 0
data_members$range13[data_members$stateper < -1.7] <- NA
data_members$range13[data_members$stateper >1.6] <- NA
table(data_members$range13)

data_members$range14<-NA

data_members$range14[data_members$stateper >= 0 & data_members$stateper<=1.7] <- 1
data_members$range14[data_members$stateper < 0 & data_members$stateper >= -1.8] <- 0
data_members$range14[data_members$stateper < -1.8] <- NA
data_members$range14[data_members$stateper >1.7] <- NA
table(data_members$range14)


data_members$range15<-NA

data_members$range15[data_members$stateper >= 0 & data_members$stateper<=1.8] <- 1
data_members$range15[data_members$stateper < 0 & data_members$stateper >= -1.9] <- 0
data_members$range15[data_members$stateper < -1.9] <- NA
data_members$range15[data_members$stateper >1.8] <- NA
table(data_members$range15)

data2<-subset(data_members, !is.na(treatment))

data_range0<-subset(data2, !is.na(range0), c(newmembers, newmembers2, newmembers3, newmembers4, prevmembers, prevmembers2, prevmembers3, prevmembers4, treatment, statename, year, partyname))

data_range0$prevmembers_lag<-data_range0$prevmembers
data_range0$prevmembers_lag[is.na(data_range0$prevmembers)]<-mean(data_range0$prevmembers, na.rm=TRUE)

data_range0$prevmembers_mis[!is.na(data_range0$prevmembers)]<-0
data_range0$prevmembers_mis[is.na(data_range0$prevmembers)]<-1

data_range1<-subset(data2, !is.na(range1), c(newmembers, newmembers2, newmembers3, newmembers4, prevmembers, prevmembers2, prevmembers3, prevmembers4, treatment, statename, year, partyname))

data_range1$prevmembers_lag<-data_range1$prevmembers
data_range1$prevmembers_lag[is.na(data_range1$prevmembers)]<-mean(data_range1$prevmembers, na.rm=TRUE)

data_range1$prevmembers_mis[!is.na(data_range1$prevmembers)]<-0
data_range1$prevmembers_mis[is.na(data_range1$prevmembers)]<-1


data_range2<-subset(data2, !is.na(range2), c(newmembers, newmembers2, newmembers3, newmembers4, prevmembers, prevmembers2, prevmembers3, prevmembers4, treatment, statename, year, partyname))

data_range2$prevmembers_lag<-data_range2$prevmembers
data_range2$prevmembers_lag[is.na(data_range2$prevmembers)]<-mean(data_range2$prevmembers, na.rm=TRUE)

data_range2$prevmembers_mis[!is.na(data_range2$prevmembers)]<-0
data_range2$prevmembers_mis[is.na(data_range2$prevmembers)]<-1


data_range3<-subset(data2, !is.na(range3), c(newmembers, newmembers2, newmembers3, newmembers4, prevmembers, prevmembers2, prevmembers3, prevmembers4, treatment, statename, year, partyname))

data_range3$prevmembers_lag<-data_range3$prevmembers
data_range3$prevmembers_lag[is.na(data_range3$prevmembers)]<-mean(data_range3$prevmembers, na.rm=TRUE)

data_range3$prevmembers_mis[!is.na(data_range3$prevmembers)]<-0
data_range3$prevmembers_mis[is.na(data_range3$prevmembers)]<-1



data_range4<-subset(data2, !is.na(range4), c(newmembers, newmembers2, newmembers3, newmembers4, prevmembers, prevmembers2, prevmembers3, prevmembers4, treatment, statename, year, partyname))

data_range4$prevmembers_lag<-data_range4$prevmembers
data_range4$prevmembers_lag[is.na(data_range4$prevmembers)]<-mean(data_range4$prevmembers, na.rm=TRUE)

data_range4$prevmembers_mis[!is.na(data_range4$prevmembers)]<-0
data_range4$prevmembers_mis[is.na(data_range4$prevmembers)]<-1



data_range5<-subset(data2, !is.na(range5), c(newmembers, newmembers2, newmembers3, newmembers4, prevmembers, prevmembers2, prevmembers3, prevmembers4, treatment, statename, year, partyname))

data_range5$prevmembers_lag<-data_range5$prevmembers
data_range5$prevmembers_lag[is.na(data_range5$prevmembers)]<-mean(data_range5$prevmembers, na.rm=TRUE)

data_range5$prevmembers_mis[!is.na(data_range5$prevmembers)]<-0
data_range5$prevmembers_mis[is.na(data_range5$prevmembers)]<-1


data_range6<-subset(data2, !is.na(range6), c(newmembers, newmembers2, newmembers3, newmembers4, prevmembers, prevmembers2, prevmembers3, prevmembers4, treatment, statename, year, partyname))

data_range6$prevmembers_lag<-data_range6$prevmembers
data_range6$prevmembers_lag[is.na(data_range6$prevmembers)]<-mean(data_range6$prevmembers, na.rm=TRUE)

data_range6$prevmembers_mis[!is.na(data_range6$prevmembers)]<-0
data_range6$prevmembers_mis[is.na(data_range6$prevmembers)]<-1


data_range7<-subset(data2, !is.na(range7), c(newmembers, newmembers2, newmembers3, newmembers4, prevmembers, prevmembers2, prevmembers3, prevmembers4, treatment, statename, year, partyname))

data_range7$prevmembers_lag<-data_range7$prevmembers
data_range7$prevmembers_lag[is.na(data_range7$prevmembers)]<-mean(data_range7$prevmembers, na.rm=TRUE)

data_range7$prevmembers_mis[!is.na(data_range7$prevmembers)]<-0
data_range7$prevmembers_mis[is.na(data_range7$prevmembers)]<-1


data_range8<-subset(data2, !is.na(range8), c(newmembers, newmembers2, newmembers3, newmembers4, prevmembers, prevmembers2, prevmembers3, prevmembers4, treatment, statename, year, partyname))

data_range8$prevmembers_lag<-data_range8$prevmembers
data_range8$prevmembers_lag[is.na(data_range8$prevmembers)]<-mean(data_range8$prevmembers, na.rm=TRUE)

data_range8$prevmembers_mis[!is.na(data_range8$prevmembers)]<-0
data_range8$prevmembers_mis[is.na(data_range8$prevmembers)]<-1

data_range9<-subset(data2, !is.na(range9), c(newmembers, newmembers2, newmembers3, newmembers4, prevmembers, prevmembers2, prevmembers3, prevmembers4, treatment, statename, year, partyname))

data_range9$prevmembers_lag<-data_range9$prevmembers
data_range9$prevmembers_lag[is.na(data_range9$prevmembers)]<-mean(data_range9$prevmembers, na.rm=TRUE)

data_range9$prevmembers_mis[!is.na(data_range9$prevmembers)]<-0
data_range9$prevmembers_mis[is.na(data_range9$prevmembers)]<-1

data_range10<-subset(data2, !is.na(range10), c(newmembers, newmembers2, newmembers3, newmembers4, prevmembers, prevmembers2, prevmembers3, prevmembers4, treatment, statename, year, partyname))

data_range10$prevmembers_lag<-data_range10$prevmembers
data_range10$prevmembers_lag[is.na(data_range10$prevmembers)]<-mean(data_range10$prevmembers, na.rm=TRUE)

data_range10$prevmembers_mis[!is.na(data_range10$prevmembers)]<-0
data_range10$prevmembers_mis[is.na(data_range10$prevmembers)]<-1


data_range11<-subset(data2, !is.na(range11), c(newmembers, newmembers2, newmembers3, newmembers4, prevmembers, prevmembers2, prevmembers3, prevmembers4, treatment, statename, year, partyname))

data_range11$prevmembers_lag<-data_range11$prevmembers
data_range11$prevmembers_lag[is.na(data_range11$prevmembers)]<-mean(data_range11$prevmembers, na.rm=TRUE)

data_range11$prevmembers_mis[!is.na(data_range11$prevmembers)]<-0
data_range11$prevmembers_mis[is.na(data_range11$prevmembers)]<-1


data_range12<-subset(data2, !is.na(range12), c(newmembers, newmembers2, newmembers3, newmembers4, prevmembers, prevmembers2, prevmembers3, prevmembers4, treatment, statename, year, partyname))

data_range12$prevmembers_lag<-data_range12$prevmembers
data_range12$prevmembers_lag[is.na(data_range12$prevmembers)]<-mean(data_range12$prevmembers, na.rm=TRUE)

data_range12$prevmembers_mis[!is.na(data_range12$prevmembers)]<-0
data_range12$prevmembers_mis[is.na(data_range12$prevmembers)]<-1


data_range13<-subset(data2, !is.na(range13), c(newmembers, newmembers2, newmembers3, newmembers4, prevmembers, prevmembers2, prevmembers3, prevmembers4, treatment, statename, year, partyname))

data_range13$prevmembers_lag<-data_range13$prevmembers
data_range13$prevmembers_lag[is.na(data_range13$prevmembers)]<-mean(data_range13$prevmembers, na.rm=TRUE)

data_range13$prevmembers_mis[!is.na(data_range13$prevmembers)]<-0
data_range13$prevmembers_mis[is.na(data_range13$prevmembers)]<-1


#write functions

pvalfunct_memb <- function(x){
  
  Z<-x$treatment
  
  numiter <- 1000
  
  set.seed(1234567)
  
  perms <-  genperms(Z,maxiter=numiter)    
  numiter <- ncol(perms) 
  
  Fstat <- summary(lm(Z~year+factor(partyname) + prevmembers_lag + prevmembers_mis, data=x))$fstatistic[1]   
  Fstat
  Fstatstore <- rep(NA,numiter)
  
  # F-statistic under the null of random assignment of Z
  for (i in 1:numiter) {
    Fstatstore[i] <- summary(lm(perms[,i]~year+factor(partyname)+ prevmembers_lag + prevmembers_mis, data=x))$fstatistic[1]   
  }
  
  est<-mean(Fstatstore >= Fstat)
  
  
  return(est)
}    

pval_.5_memb <- pvalfunct_memb(data_range1)

N_.5_treatment_memb<-table(data_range1$treatment)[2]
N_.5_control_memb<-table(data_range1$treatment)[1]

pval_.6_memb <- pvalfunct_memb(data_range2)

N_.6_treatment_memb<-table(data_range2$treatment)[2]
N_.6_control_memb<-table(data_range2$treatment)[1]

pval_.7_memb <- pvalfunct_memb(data_range3) 

N_.7_treatment_memb<-table(data_range3$treatment)[2]
N_.7_control_memb<-table(data_range3$treatment)[1]

pval_.8_memb<-pvalfunct_memb(data_range4) 

N_.8_treatment_memb<-table(data_range4$treatment)[2]
N_.8_control_memb<-table(data_range4$treatment)[1]

pval_.9_memb<-pvalfunct_memb(data_range5)

N_.9_treatment_memb<-table(data_range5$treatment)[2]
N_.9_control_memb<-table(data_range5$treatment)[1]

pval_1.0_memb<-pvalfunct_memb(data_range6)

N_1.0_treatment_memb<-table(data_range6$treatment)[2]
N_1.0_control_memb<-table(data_range6$treatment)[1]

pval_1.1_memb<-pvalfunct_memb(data_range7)

N_1.1_treatment_memb<-table(data_range7$treatment)[2]
N_1.1_control_memb<-table(data_range7$treatment)[1]

pval_1.2_memb<-pvalfunct_memb(data_range8) 

N_1.2_treatment_memb<-table(data_range8$treatment)[2]
N_1.2_control_memb<-table(data_range8$treatment)[1]

pval_1.3_memb<-pvalfunct_memb(data_range9)

N_1.3_treatment_memb<-table(data_range9$treatment)[2]
N_1.3_control_memb<-table(data_range9$treatment)[1]

pval_1.4_memb<-pvalfunct_memb(data_range10) 

N_1.4_treatment_memb<-table(data_range10$treatment)[2]
N_1.4_control_memb<-table(data_range10$treatment)[1]


pval_1.5_memb<-pvalfunct_memb(data_range11)

N_1.5_treatment_memb<-table(data_range11$treatment)[2]
N_1.5_control_memb<-table(data_range11$treatment)[1]

pval_1.6_memb<-pvalfunct_memb(data_range12)

N_1.6_treatment_memb<-table(data_range12$treatment)[2]
N_1.6_control_memb<-table(data_range12$treatment)[1]


pval_1.7_memb<-pvalfunct_memb(data_range13)

N_1.7_treatment_memb<-table(data_range13$treatment)[2]
N_1.7_control_memb<-table(data_range13$treatment)[1]



#Save estimates to columns

Row1<-cbind(pval_.5, pval_.6, pval_.7, pval_.8, NA, NA, NA, NA, NA, NA, NA, NA, NA)

Row2<-cbind(N_.5_treatment, N_.6_treatment, N_.7_treatment, N_.8_treatment, NA, NA, NA, NA, NA, NA, NA, NA, NA)

Row3<-cbind(N_.5_control, N_.6_control, N_.7_control, N_.8_control, NA, NA, NA, NA, NA, NA, NA,  NA, NA)

Row4<-cbind(pval_.5_below, pval_.6_below, pval_.7_below, NA, NA, NA, NA, NA, NA, NA, NA,  NA, NA)

Row5<-cbind(N_.5_below_treatment, N_.6_below_treatment, N_.7_below_treatment,NA, NA, NA, NA, NA, NA, NA, NA,  NA, NA)

Row6<-cbind(N_.5_below_control, N_.6_below_control, N_.7_below_control, NA, NA, NA, NA, NA, NA, NA, NA,  NA, NA)

Row7<-cbind(pval_.5_above, pval_.6_above, pval_.7_above, pval_.8_above, pval_.9_above, pval_1.0_above, pval_1.1_above, pval_1.2_above, NA, NA, NA,  NA, NA)

Row8<-cbind(N_.5_above_treatment, N_.6_above_treatment, N_.7_above_treatment, N_.8_above_treatment, N_.9_above_treatment, N_1.0_above_treatment, N_1.1_above_treatment, N_1.2_above_treatment, NA, NA, NA,  NA, NA)

Row9<-cbind(N_.5_above_control, N_.6_above_control, N_.7_above_control, N_.8_above_control, N_.9_above_control, N_1.0_above_control, N_1.1_above_control, N_1.2_above_control, NA, NA, NA,  NA, NA)

Row10<-cbind(pval_.5_memb, pval_.6_memb, pval_.7_memb, pval_.8_memb, pval_.9_memb, pval_1.0_memb, pval_1.1_memb, pval_1.2_memb, pval_1.3_memb, pval_1.4_memb, pval_1.5_memb, pval_1.6_memb, pval_1.7_memb)

Row11<-cbind(N_.5_treatment_memb, N_.6_treatment_memb, N_.7_treatment_memb, N_.8_treatment_memb, N_.9_treatment_memb, N_1.0_treatment_memb, N_1.1_treatment_memb, N_1.2_treatment_memb, N_1.3_treatment_memb, N_1.4_treatment_memb, N_1.5_treatment_memb, N_1.6_treatment_memb, N_1.7_treatment_memb)

Row12<-cbind(N_.5_control_memb, N_.6_control_memb, N_.7_control_memb, N_.8_control_memb, N_.9_control_memb, N_1.0_control_memb, N_1.1_control_memb, N_1.2_control_memb,  N_1.3_control_memb, N_1.4_control_memb, N_1.5_control_memb, N_1.6_control_memb, N_1.7_control_memb)


#Bind rows to table

library(xtable)

TableA.1<-rbind(Row1, Row2, Row3, Row4, Row5, Row6, Row7, Row8, Row9, Row10, Row11, Row12)

digits<-NA

digits<-matrix(0,nrow=12,ncol=14)

digits[c(1,1),]<-3
digits[c(1,4),]<-3
digits[c(1,7),]<-3
digits[c(1,10),]<-3

colnames(TableA.1)[1] <- "0.5"
colnames(TableA.1)[2] <- "0.6"
colnames(TableA.1)[3] <- "0.7"
colnames(TableA.1)[4] <- "0.8"
colnames(TableA.1)[5] <- "0.9"
colnames(TableA.1)[6] <- "1.0"
colnames(TableA.1)[7] <- "1.1"
colnames(TableA.1)[8] <- "1.2"
colnames(TableA.1)[9] <- "1.3"
colnames(TableA.1)[10] <- "1.4"
colnames(TableA.1)[11] <- "1.5"
colnames(TableA.1)[12] <- "1.6"
colnames(TableA.1)[13] <- "1.7"
rownames(TableA.1)[1] <- "P-values full"
rownames(TableA.1)[2] <- "N [treated] full"
rownames(TableA.1)[3] <- "N [control] full"
rownames(TableA.1)[4] <- "P-values below"
rownames(TableA.1)[5] <- "N [treated] below"
rownames(TableA.1)[6] <- "N [control] below"
rownames(TableA.1)[7] <- "P-values above"
rownames(TableA.1)[8] <- "N [treated] above"
rownames(TableA.1)[9] <- "N [control] above"
rownames(TableA.1)[10] <- "P-values members"
rownames(TableA.1)[11] <- "N [treated] members"
rownames(TableA.1)[12] <- "N [control] members"

xtable(TableA.1, digits = digits)




#############################
# Analysis Table 1 lower part
############################


rm(list = ls())

data <- read.dta("data.dta")


#Define functions


LATE_funct <- function(x){
  
  late_save<-round(ate, digits = 3)
  
  symp <- symnum(pval, corr = FALSE,
                 cutpoints = c(0.001, 0.01, .05, .10, 1),
                 symbols = c("***","**", "*", ""))
  sig<-noquote(cbind(P.val = format(pval), Signif = symp))
  
  sig2<-as.vector(matrix(c(sig), ncol=2, nrow=1, byrow=TRUE))
  
  sig3<-sig2[2]
  
  late_save2 <- paste(late_save, sig3, sep="")
  
  return(late_save2)
}

CI_funct <- function(x){
  
  x<-dispdist(distout,x)$quantile 
  
  CI1<-as.vector(x[1])
  
  CI2<-as.vector(x[2])
  
  CI1<-round(CI1, digits = 3)
  
  CI2<-round(CI2, digits = 3)
  
  CI_save <- paste(CI1, CI2)
  
  return(CI_save)
}



# Define treatment, outcome and covariate

data$treatment[data$forcing>= 0] <- 1
data$treatment[data$forcing< 0] <- 0

table(data$treatment)

data$range3<-NA

data$range3[data$forcing >= 0 & data$forcing <=0.6] <- 1
data$range3[data$forcing  < 0 & data$forcing  >= -0.7] <- 0
data$range3[data$forcing  < -0.7] <- NA
data$range3[data$forcing  >0.6] <- NA
table(data$range3)


#Estimation

data_range3<-subset(data, !is.na(range3), c(treatment, extremeright,  greens, fdp, state, statelag1, year, newper, partyname))

data_analysis<-subset(data_range3,!is.na(newper))

Z <- data_analysis$treatment
Y <- data_analysis$newper
  
# Check values
N_total_treatment<-table(Z)[2]
N_total_control<-table(Z)[1]
table(Y)


# Create probabilities of local quasi-random assignment to treatment and control
probs <- genprobexact(Z) 
probs

# Estimate LATE
ate <- estate(Y,Z,prob=probs) 
ate

set.seed(1234567)

perms <- genperms(Z,maxiter=1000)   

Ys <- genouts(Y,Z,ate=0)    
distout <- gendist(Ys,perms,prob=probs)  
pval<-dispdist(distout,ate)$two.tailed.p.value.abs 

Ys <- genouts(Y,Z,ate=ate)
distout <- gendist(Ys,perms,prob=probs)

LATE<-LATE_funct(ate)

LATE

CI<-CI_funct(ate)

CI

Save_total<-rbind(LATE, CI)

Save_total 


#below

data$firsttwoyears<-NA

data$firsttwoyears[data$days<=851]<-1

data_below2<-subset(data,!is.na(firsttwoyears))

data_below2$treatment[data_below2$forcing>= 0] <- 1
data_below2$treatment[data_below2$forcing< 0] <- 0

table(data_below2$treatment)

data_below2$range2<-NA

data_below2$range2[data_below2$forcing >= 0 & data_below2$forcing <=0.6] <- 1
data_below2$range2[data_below2$forcing  < 0 & data_below2$forcing  >= -0.5] <- 0
data_below2$range2[data_below2$forcing  < -0.6] <- NA
data_below2$range2[data_below2$forcing  >0.5] <- NA
table(data_below2$range2)

data_below_range2<-subset(data_below2, !is.na(range2), c( treatment, extremeright,  greens, fdp, state,  year, newper))

data_analysis2<-subset(data_below_range2,!is.na(newper))

Z <- data_analysis2$treatment
Y <- data_analysis2$newper

# Check values
table(Z)
N_below_treatment<-table(Z)[2]
N_below_control<-table(Z)[1]
table(Y)

# Create probabilities of local quasi-random assignment to treatment and control
probs <- genprobexact(Z) 
probs

# Estimate LATE
ate <- estate(Y,Z,prob=probs) 
ate

set.seed(1234567)

perms <- genperms(Z,maxiter=5000)   

Ys <- genouts(Y,Z,ate=0)    
distout <- gendist(Ys,perms,prob=probs)  
pval<-dispdist(distout,ate)$two.tailed.p.value.abs #0.0195

Ys <- genouts(Y,Z,ate=ate)
distout <- gendist(Ys,perms,prob=probs)

LATE<-LATE_funct(ate)

LATE

CI<-CI_funct(ate)

CI

Save_below<-rbind(LATE, CI)

Save_below



#Above

data$lasttwoyears<-NA

data$lasttwoyears[data$days>851]<-1

data_above2<-subset(data,!is.na(lasttwoyears))

data_above2$treatment[data_above2$forcing>= 0] <- 1
data_above2$treatment[data_above2$forcing< 0] <- 0

data_above2$range7<-NA

data_above2$range7[data_above2$forcing >= 0 & data_above2$forcing <=1.0] <- 1
data_above2$range7[data_above2$forcing  < 0 & data_above2$forcing  >= -1.1] <- 0
data_above2$range7[data_above2$forcing  < -1.1] <- NA
data_above2$range7[data_above2$forcing  >1.0] <- NA
table(data_above2$range7)

data_above_range7<-subset(data_above2, !is.na(range7), c( treatment, extremeright,  greens, fdp, state,  year, newper))

data_analysis3<-subset(data_above_range7,!is.na(newper))

Z <- data_analysis3$treatment
Y <- data_analysis3$newper

# Check values
table(Z)
N_above_treatment<-table(Z)[2]
N_above_control<-table(Z)[1]
table(Y)

# Create probabilities of local quasi-random assignment to treatment and control
probs <- genprobexact(Z) 
probs

# Estimate LATE
ate <- estate(Y,Z,prob=probs) 
ate

set.seed(1234567)

perms <- genperms(Z,maxiter=5000)   

Ys <- genouts(Y,Z,ate=0)    
distout <- gendist(Ys,perms,prob=probs)  
pval<-dispdist(distout,ate)$two.tailed.p.value.abs 

Ys <- genouts(Y,Z,ate=ate)
distout <- gendist(Ys,perms,prob=probs)

LATE<-LATE_funct(ate)

LATE

CI<-CI_funct(ate)

CI

Save_above<-rbind(LATE, CI)

Save_above 



#Table

Row1<-cbind(Save_total, Save_below, Save_above)
Row2<-cbind(N_total_treatment, N_below_treatment, N_above_treatment)
Row3<-cbind(N_total_control, N_below_control, N_above_control)

Table1_lower<-rbind(Row1, Row2, Row3)

digits<-NA

digits<-matrix(0,nrow=4,ncol=4)

digits[c(1,1),]<-3

colnames(Table1_lower)[1] <- "Full Sample"
colnames(Table1_lower)[2] <- "Below Median"
colnames(Table1_lower)[3] <- "Above Median"
rownames(Table1_lower)[3] <- "N [treated]"
rownames(Table1_lower)[4] <- "N [control]"

xtable(Table1_lower, digits = digits)





#############################
# Analysis Table 5 lower part
############################


LATE_funct_memb <- function(x){
  
  late_save<-round(ate, digits = 1)
  
  symp <- symnum(pval, corr = FALSE,
                 cutpoints = c(0.001, 0.01, .05, .10, 1),
                 symbols = c("***", "**", "*", ""))
  sig<-noquote(cbind(P.val = format(pval), Signif = symp))
  
  sig2<-as.vector(matrix(c(sig), ncol=2, nrow=1, byrow=TRUE))
  
  sig3<-sig2[2]
  
  late_save2 <- paste(late_save, sig3, sep="")
  
  return(late_save2)
}

CI_funct_memb <- function(x){
  
  x<-dispdist(distout,x)$quantile #0.00612151 0.06234187 
  
  CI1<-as.vector(x[1])
  
  CI2<-as.vector(x[2])
  
  CI1<-round(CI1, digits = 1)
  
  CI2<-round(CI2, digits = 1)
  
  CI_save <- paste(CI1, CI2)
  
  return(CI_save)
}


data_members <- read.dta("membership.dta")

data_members$treatment[data_members$forcing>= 0] <- 1
data_members$treatment[data_members$forcing< 0] <- 0

table(data_members$treatment)

data_members$range12<-NA

data_members$range12[data_members$forcing >= 0 & data_members$forcing <=1.5] <- 1
data_members$range12[data_members$forcing  < 0 & data_members$forcing  >= -1.6] <- 0
data_members$range12[data_members$forcing  < -1.6] <- NA
data_members$range12[data_members$forcing  >1.5] <- NA
table(data_members$range12)

data_range12<-subset(data_members, !is.na(range12), c(membdif1, membdif2, membdif3, membdif4, newmembers, newmembers2, newmembers3, newmembers4, treatment))

data_analysis<-subset(data_range12,!is.na(newmembers))

Z <- data_analysis$treatment
Y <- data_analysis$newmembers

# Check values
table(Z)
table(Y)

# Create probabilities of local quasi-random assignment to treatment and control
probs <- genprobexact(Z) 
probs

# Estimate LATE
ate <- estate(Y,Z,prob=probs) 
ate

set.seed(1234567)

perms <- genperms(Z,maxiter=5000)   

Ys <- genouts(Y,Z,ate=0)    
distout <- gendist(Ys,perms,prob=probs)  
pval<-dispdist(distout,ate)$two.tailed.p.value.abs #0.0195

Ys <- genouts(Y,Z,ate=ate)
distout <- gendist(Ys,perms,prob=probs)

LATE<-LATE_funct_memb(ate)

LATE

CI<-CI_funct_memb(ate)

CI

members1_abs<-rbind(LATE, CI)

members1_abs

members1_abs_N_treat<-table(Z)[2]
members1_abs_N_control<-table(Z)[1]

data_analysis<-subset(data_range12,!is.na(newmembers2))

Z <- data_analysis$treatment
Y <- data_analysis$newmembers2

# Check values
table(Z)
table(Y)

# Create probabilities of local quasi-random assignment to treatment and control
probs <- genprobexact(Z) 
probs

# Estimate LATE
ate <- estate(Y,Z,prob=probs) 
ate

set.seed(1234567)

perms <- genperms(Z,maxiter=5000)   

Ys <- genouts(Y,Z,ate=0)    
distout <- gendist(Ys,perms,prob=probs)  
pval<-dispdist(distout,ate)$two.tailed.p.value.abs #0.0195

Ys <- genouts(Y,Z,ate=ate)
distout <- gendist(Ys,perms,prob=probs)

LATE<-LATE_funct_memb(ate)

LATE

CI<-CI_funct_memb(ate)

CI

members2_abs<-rbind(LATE, CI)

members2_abs

members2_abs_N_treat<-table(Z)[2]
members2_abs_N_control<-table(Z)[1]

data_analysis<-subset(data_range12,!is.na(newmembers3))

Z <- data_analysis$treatment
Y <- data_analysis$newmembers3

# Check values
table(Z)
table(Y)

# Create probabilities of local quasi-random assignment to treatment and control
probs <- genprobexact(Z) 
probs

# Estimate LATE
ate <- estate(Y,Z,prob=probs) 
ate

set.seed(1234567)

perms <- genperms(Z,maxiter=5000)   

Ys <- genouts(Y,Z,ate=0)    
distout <- gendist(Ys,perms,prob=probs)  
pval<-dispdist(distout,ate)$two.tailed.p.value.abs #0.0195

Ys <- genouts(Y,Z,ate=ate)
distout <- gendist(Ys,perms,prob=probs)

LATE<-LATE_funct_memb(ate)

LATE

CI<-CI_funct_memb(ate)

CI

members3_abs<-rbind(LATE, CI)

members3_abs

members3_abs_N_treat<-table(Z)[2]
members3_abs_N_control<-table(Z)[1]

data_analysis<-subset(data_range12,!is.na(newmembers4))

Z <- data_analysis$treatment
Y <- data_analysis$newmembers4

# Check values
table(Z)
table(Y)

# Create probabilities of local quasi-random assignment to treatment and control
probs <- genprobexact(Z) 
probs

# Estimate LATE
ate <- estate(Y,Z,prob=probs) 
ate

set.seed(1234567)

perms <- genperms(Z,maxiter=5000)   

Ys <- genouts(Y,Z,ate=0)    
distout <- gendist(Ys,perms,prob=probs)  
pval<-dispdist(distout,ate)$two.tailed.p.value.abs #0.0195

Ys <- genouts(Y,Z,ate=ate)
distout <- gendist(Ys,perms,prob=probs)

LATE<-LATE_funct_memb(ate)

LATE

CI<-CI_funct_memb(ate)

CI

members4_abs<-rbind(LATE, CI)

members4_abs

members4_abs_N_treat<-table(Z)[2]
members4_abs_N_control<-table(Z)[1]


#Change in members


data_analysis<-subset(data_range12,!is.na(membdif1))

Z <- data_analysis$treatment
Y <- data_analysis$membdif1

# Check values
table(Z)


# Create probabilities of local quasi-random assignment to treatment and control
probs <- genprobexact(Z) 
probs

# Estimate LATE
ate <- estate(Y,Z,prob=probs) 
ate

set.seed(1234567)

perms <- genperms(Z,maxiter=5000)   

Ys <- genouts(Y,Z,ate=0)    
distout <- gendist(Ys,perms,prob=probs)  
pval<-dispdist(distout,ate)$two.tailed.p.value.abs #0.0195

Ys <- genouts(Y,Z,ate=ate)
distout <- gendist(Ys,perms,prob=probs)

LATE<-LATE_funct_memb(ate)

LATE

CI<-CI_funct_memb(ate)

CI

members1<-rbind(LATE, CI)

members1

members1_N_treat<-table(Z)[2]
members1_N_control<-table(Z)[1]


data_analysis<-subset(data_range12,!is.na(membdif2))

Z <- data_analysis$treatment
Y <- data_analysis$membdif2

# Check values
table(Z)

# Create probabilities of local quasi-random assignment to treatment and control
probs <- genprobexact(Z) 
probs

# Estimate LATE
ate <- estate(Y,Z,prob=probs) 
ate

set.seed(1234567)

perms <- genperms(Z,maxiter=5000)   

Ys <- genouts(Y,Z,ate=0)    
distout <- gendist(Ys,perms,prob=probs)  
pval<-dispdist(distout,ate)$two.tailed.p.value.abs #0.0195

Ys <- genouts(Y,Z,ate=ate)
distout <- gendist(Ys,perms,prob=probs)

LATE<-LATE_funct_memb(ate)

LATE

CI<-CI_funct_memb(ate)

CI

members2<-rbind(LATE, CI)

members2

members2_N_treat<-table(Z)[2]
members2_N_control<-table(Z)[1]

data_analysis<-subset(data_range12,!is.na(membdif3))

Z <- data_analysis$treatment
Y <- data_analysis$membdif3

# Check values
table(Z)
table(Y)

# Create probabilities of local quasi-random assignment to treatment and control
probs <- genprobexact(Z) 
probs

# Estimate LATE
ate <- estate(Y,Z,prob=probs) 
ate

set.seed(1234567)

perms <- genperms(Z,maxiter=5000)   

Ys <- genouts(Y,Z,ate=0)    
distout <- gendist(Ys,perms,prob=probs)  
pval<-dispdist(distout,ate)$two.tailed.p.value.abs #0.0195

Ys <- genouts(Y,Z,ate=ate)
distout <- gendist(Ys,perms,prob=probs)

LATE<-LATE_funct_memb(ate)

LATE

CI<-CI_funct_memb(ate)

CI

members3<-rbind(LATE, CI)

members3

members3_N_treat<-table(Z)[2]
members3_N_control<-table(Z)[1]


data_analysis<-subset(data_range12,!is.na(membdif4))

Z <- data_analysis$treatment
Y <- data_analysis$membdif4

# Check values
table(Z)
table(Y)

# Create probabilities of local quasi-random assignment to treatment and control
probs <- genprobexact(Z) 
probs

# Estimate LATE
ate <- estate(Y,Z,prob=probs) 
ate

set.seed(1234567)

perms <- genperms(Z,maxiter=5000)   

Ys <- genouts(Y,Z,ate=0)    
distout <- gendist(Ys,perms,prob=probs)  
pval<-dispdist(distout,ate)$two.tailed.p.value.abs #0.0195

Ys <- genouts(Y,Z,ate=ate)
distout <- gendist(Ys,perms,prob=probs)

LATE<-LATE_funct_memb(ate)

LATE

CI<-CI_funct_memb(ate)

CI

members4<-rbind(LATE, CI)

members4

members4_N_treat<-table(Z)[2]
members4_N_control<-table(Z)[1]


#Table

Row1<-cbind(members1_abs, members2_abs, members3_abs, members4_abs)

Row2<-cbind(members1_abs_N_treat, members2_abs_N_treat, members3_abs_N_treat, members4_abs_N_treat)

Row3<-cbind(members1_abs_N_control, members2_abs_N_control, members3_abs_N_control, members4_abs_N_control)

Row4<-cbind(members1, members2, members3, members4)

Row5<-cbind(members1_N_treat, members2_N_treat, members3_N_treat, members4_N_treat)

Row6<-cbind(members1_N_control, members2_N_control, members3_N_control, members4_N_control)

Table5_lower<-rbind(Row1, Row2, Row3, Row4, Row5, Row6)

digits<-NA

digits<-matrix(0,nrow=8,ncol=5)

colnames(Table5_lower)[1] <- "Members t+1"
colnames(Table5_lower)[2] <- "Members t+2"
colnames(Table5_lower)[3] <- "Members t+3"
colnames(Table5_lower)[4] <- "Members t+4"
rownames(Table5_lower)[1] <- "Treatment effect absolute"
rownames(Table5_lower)[2] <- "CI absolute"
rownames(Table5_lower)[3] <- "N [treated] abs"
rownames(Table5_lower)[4] <- "N [control] abs"
rownames(Table5_lower)[5] <- "Treatment effect change"
rownames(Table5_lower)[6] <- "CI change"
rownames(Table5_lower)[7] <- "N [treated] change"
rownames(Table5_lower)[8] <- "N [control] change"

xtable(Table5_lower, digits = digits)



#############################
# Appendix Figure A.9 and Table A.10
############################

rm(list = ls())

data <- read.dta("data.dta")

data$treatment[data$forcing>= 0] <- 1
data$treatment[data$forcing< 0] <- 0

data$range_total<-NA

data$range_total[data$forcing >= 0 & data$forcing <=4.9] <- 1
data$range_total[data$forcing  < 0 & data$forcing  >=- 5] <- 0
data$range_total[data$forcing  < -5] <- NA
data$range_total[data$forcing  >4.9] <- NA
table(data$range_total)


data_total_range_5<-subset(data, !is.na(range_total), c(treatment, extremeright, greens, fdp, state, year, newper, partyname, partycode))

data_analysis5<-subset(data_total_range_5,!is.na(newper))

hist(data_analysis5$year)

table(data_analysis5$year)


#A.10 Column 1

table(data_analysis5$treatment)

table(data_analysis5$partyname) 

table(data_analysis5$partyname, data_analysis5$partycode)


#Figure A.9a

pdf(paste("Figure_year_window5.pdf"),w=7,h=5)
hist(data_analysis5$year, breaks=68, xlab=("Year"), ylim = c(0, 70), main = paste(""))
dev.off()  

############

data$treatment[data$forcing>= 0] <- 1
data$treatment[data$forcing< 0] <- 0

data$range_total<-NA

data$range_total[data$forcing >= 0 & data$forcing <=3.9] <- 1
data$range_total[data$forcing  < 0 & data$forcing  >=- 4] <- 0
data$range_total[data$forcing  < -4] <- NA
data$range_total[data$forcing  >3.9] <- NA
table(data$range_total)

data_total_range_4<-subset(data, !is.na(range_total), c(treatment, extremeright, greens, fdp, state, year, newper, partyname, partycode))

data_analysis4<-subset(data_total_range_4,!is.na(newper))

hist(data_analysis4$year)

table(data_analysis4$year)

# Table A.10 Column 2

table(data_analysis4$treatment)

table(data_analysis4$partyname)

table(data_analysis4$partyname, data_analysis4$partycode) 


#########

data$treatment[data$forcing>= 0] <- 1
data$treatment[data$forcing< 0] <- 0

data$range_total<-NA

data$range_total[data$forcing >= 0 & data$forcing <=0.6] <- 1
data$range_total[data$forcing  < 0 & data$forcing  >=- 0.7] <- 0
data$range_total[data$forcing  < -0.7] <- NA
data$range_total[data$forcing  >0.6] <- NA
table(data$range_total)


data_total_range_07<-subset(data, !is.na(range_total), c(treatment, extremeright, greens, fdp, state, year, newper, partyname, partycode))

data_analysis07<-subset(data_total_range_07,!is.na(newper))

table(data_analysis07$year)

#Table A.10 Column 3

table(data_analysis07$treatment)

table(data_analysis07$partyname)

table(data_analysis07$partyname, data_analysis07$partycode) 

#Figure A.9b

pdf(paste("Figure_year_window07.pdf"),w=7,h=5)
hist(data_analysis07$year, breaks=68, xlab=("Year"), main = paste(""))
dev.off()  